'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
var toString = Object.prototype.toString;


var isArray = function isArray(arg) {
  return toString.call(arg) === '[object Array]';
};

var addUrlParam = function addUrlParam(name, value) {
  var currentUrl = window.location.href;
  var reg = void 0;
  if (/\?/g.test(currentUrl)) {
    reg = new RegExp(name + '=[-\\w]{4,25}', 'g');
    if (reg.test(currentUrl)) {
      currentUrl = currentUrl.replace(reg, name + '=' + value);
    } else {
      currentUrl += '&' + name + '=' + value;
    }
  } else {
    currentUrl += '?' + name + '=' + value;
  }
  return currentUrl;
};

// 格式化方法类型
var FORMATTER_TYPES = {
  LABEL_FORMATTER: 'label', // 回填值显示
  OPTION_FORMATTER: 'option' // panel选项显示

};

exports.default = {
  isArray: isArray,
  addUrlParam: addUrlParam,
  FORMATTER_TYPES: FORMATTER_TYPES
};